<template>
  <page-header-wrapper>
    <a-card class="table-card">
      <JeepaySearchForm :searchFunc="searchFunc" :resetFunc="onReset">
        <jeepay-text-up v-if="$hasAgentEnt()" v-model:value="vdata.searchData['mchServiceName']" :placeholder="'服务商号/名称'" />
        <JeepaySearchInfoInput v-model:value="vdata.searchData['mchUserName']" placeholder="用户号/名称" :textUpStyle="true" :mchNoAndName="true" showType="MCH" />
        <jeepay-text-up v-model:value="vdata.searchData.batchId" :placeholder="'批次号'" />
        <jeepay-text-up v-model:value="vdata.searchData.deviceNo" :placeholder="'设备号'" />
        <jeepay-text-up v-model:value="vdata.searchData.alipayShopId" :placeholder="'蚂蚁店铺ID'" />
        <a-form-item label="" class="table-search-item">
          <a-select v-model:value="vdata.searchData.state" placeholder="状态">
            <a-select-option value="">全部</a-select-option>
            <a-select-option value="0">禁用</a-select-option>
            <a-select-option value="1">启用</a-select-option>
          </a-select>
        </a-form-item>
        <a-form-item label="" class="table-search-item">
          <a-select v-model:value="vdata.searchData.bindState" placeholder="绑定状态">
            <a-select-option value="">全部</a-select-option>
            <a-select-option value="0">未绑定</a-select-option>
            <a-select-option value="1">已绑定</a-select-option>
          </a-select>
        </a-form-item>
      </JeepaySearchForm>
      <!-- 列表渲染 -->
      <JeepayTable
        ref="infoTable"
        :init-data="false"
        :req-table-data-func="reqTableDataFunc"
        :table-columns="tableColumns"
        :search-data="vdata.searchData"
        :rowSelection="{ type: 'checkbox', selectedRowKeys: vdata.allotDeviceIdList, onChange: infoTableSelectChangeFunc }"
        row-key="deviceId"
        @btnLoadClose="btnLoading=false"
      >
        <template #topBtnSlot>
          <a-button v-if="$access('ENT_DEVICE_AUTO_POS_ADD')" type="primary" @click="addFunc"><plus-outlined />设备入库</a-button>
          <a-button v-if="$access('ENT_DEVICE_AUTO_POS_ALLOT') && $hasAgentEnt()" type="primary" @click="allotBatchFunc"><partition-outlined />勾选划拨/收回</a-button>
          <a-button v-if="$access('ENT_DEVICE_AUTO_POS_ALLOT') && $hasAgentEnt()" type="primary" @click="allotByBatchIdFunc"><partition-outlined />批次划拨/收回</a-button>
          <a-button v-if="$access('ENT_DEVICE_AUTO_POS_DEL')" type="danger" @click="deleteBatchFunc"><delete-outlined />批量删除</a-button>
        </template>

        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'bindState'">
            <template v-if="record.bindState == 0"><exclamation-circle-outlined />未绑定</template>
            <template v-else>已绑定商户: {{ record.mchNo }} ({{ record.mchName }})<br>应用： {{ record.appId }}<br>门店： {{ record.storeId }} ({{ record.storeName }})</template>
          </template>
          
          <template v-if="column.key === 'state'">
            <JeepayTableColState :state="record.state" :showSwitchType="$access('ENT_DEVICE_AUTO_POS_EDIT')" :onChange="(state) => { return updateState(record.deviceId, state)}" />
          </template>

          <template v-if="column.key === 'alipayBindState'">
            <a-tag v-if="record.alipayBindState==1" color="green">已绑定</a-tag>
            <a-span v-if="record.alipayBindState==1 && record.alipayShopId">蚂蚁店铺ID：{{ record.alipayShopId }}</a-span>
            <a-tag v-else-if="record.alipayBindState==0" color="red">未绑定</a-tag>
          </template>

          <template v-if="column.key === 'operation'">
            <!-- 操作列插槽 -->
            <JeepayTableColumns>
              <a-button v-if="$access('ENT_DEVICE_AUTO_POS_EDIT')" type="link" @click="editFunc(record)">修改</a-button>
              <a-button v-if="$access('ENT_DEVICE_AUTO_POS_EDIT')" type="link" @click="bindFunc(record)">绑定</a-button>
              <a-button v-if="$access('ENT_DEVICE_AUTO_POS_EDIT')" type="link" @click="deBindFunc(record.deviceId)">解绑</a-button>
              <a-button v-if="$access('ENT_DEVICE_AUTO_POS_ALLOT') && $hasAgentEnt()" type="link" @click="allotFunc(record)">划拨/收回</a-button>
              <a-button v-if="$access('ENT_DEVICE_RUYI_BIND')" type="link" @click="alipayIotBindShowFunc(record)">绑定蚂蚁店铺</a-button>
              <a-button v-if="$access('ENT_DEVICE_RUYI_BIND') && record.alipayBindState == 1" type="link" style="color: red" @click="alipayIotUnBindFunc(record.deviceId)">解绑蚂蚁店铺</a-button>
              <a-button v-if="$access('ENT_DEVICE_AUTO_POS_DEL')" type="link" style="color: red" @click="delFunc(record.deviceId)">删除</a-button>
            </JeepayTableColumns>
          </template>
        </template>
      </JeepayTable>
    </a-card>

    <!-- 批次号划拨弹窗 -->
    <a-modal v-model:visible="vdata.allotByBatchIdVisible" title="按批次号划拨设备" @ok="allotOk">
      <a-form ref="allotFormModel" :model="vdata.allotObject" layout="vertical" :rules="vdata.allotRules">
        <a-form-item label="批次号：" name="batchId">
          <a-input v-model:value="vdata.allotObject.batchId" placeholder="请输入批次号" />
        </a-form-item>
      </a-form>
    </a-modal>

    <!-- 新增页面组件  -->
    <InfoAddOrEdit ref="infoAddOrEdit" :callbackFunc="searchFunc" />
    <!-- 绑定组件  -->
    <Bind ref="bind" :callbackFunc="searchFunc" />

    <!-- 绑定蚂蚁店铺弹窗  -->
    <a-modal :visible="vdata.alipayIotBindShow" title="绑定/解绑蚂蚁店铺" @ok="alipayIotBindFunc(vdata.alipayIotBindObject.deviceId, 1)" @cancel="() => vdata.alipayIotBindShow = false">
      <a-form ref="alipayIotBindModel" :model="vdata.alipayIotBindObject" layout="vertical">
        <a-col :span="24">
          <a-form-item label="选择门店" name="storeId">
            <a-select v-model:value="vdata.alipayIotBindObject.storeId" placeholder="请选择门店">
              <a-select-option v-for="(d, index) in vdata.storeList" :key="index" v-model:value="d.storeId">
                {{ d.storeName }} 【蚂蚁店铺ID：{{ d.alipayShopId }} 】
              </a-select-option>
            </a-select>
          </a-form-item>
        </a-col>
      </a-form>
    </a-modal>

    <JeepayModelAgentList ref="jeepayModelAgentList" showType="AGENT" @selectFinishFunc="searchAgentFinishFunc" />
  </page-header-wrapper>
</template>
<script setup lang="ts">
import { API_URL_STORE_DEVICE, API_URL_MCH_STORE_LIST, API_ALIPAY_IOT, req, reqLoad, $allotDevice, $batchDelDevice, $unbindDevice } from '@/api/manage'
import InfoAddOrEdit from './AddOrEdit.vue'
import Bind from '../Bind.vue'
import { ref, reactive, getCurrentInstance, onMounted } from 'vue'
import { useRoute } from 'vue-router'

const { $infoBox, $access, $hasAgentEnt } = getCurrentInstance()!.appContext.config.globalProperties

const jeepayModelAgentList = ref()
const infoAddOrEdit = ref()
const bind = ref()
const infoTable = ref()
const allotFormModel = ref()

const deviceType = 7

let tableColumns = reactive([
  { title: '设备号', fixed: 'left', dataIndex: 'deviceNo' },
  { title: '批次号', dataIndex: 'batchId' },
  { title: '服务商号', dataIndex: 'agentNo', agentEntCol: true},
  { key: 'bindState', title: '绑定商户信息' },
  { key: 'state', title: '状态' },
  { key: 'alipayBindState', title: '蚂蚁店铺绑定状态' },
  { dataIndex: 'createdAt', title: '创建日期' },
  { key: 'operation', title: '操作', fixed: 'right', align: 'center'}
])

  let btnLoading = ref(false)
  const vdata = reactive({
    allotByBatchIdVisible: false, // 批次划拨设备弹窗
    searchData: {} as any,
    allotObject: {
      agentNo: null, // 划拨代理商号
      allotType: null, // 划拨类型：select-勾选划拨  batch-批次划拨
      batchId: null, // 批次号，划拨类型为 batch-批次划拨 时必填
      allotDeviceIds: [] as any, // 要划拨的设备ID，划拨类型为 select-勾选划拨 时必填
    } as any, // 划拨设备对象
    allotDeviceIdList: [] as any, // 要划拨的设备ID，划拨类型为 select-勾选划拨 时必填
    allotRules: {
      batchId: [{ required: true, message: '请输入批次号', trigger: 'blur' }]
    },
    alipayIotBindShow: false, // 蚂蚁店铺绑定弹窗
    alipayIotBindObject: {} as any, // 蚂蚁店铺绑定对象
    storeList: {} as any
  }) as any

  onMounted(() => {
    vdata.searchData.mchNo = useRoute().query.mchNo
    searchFunc()
  })

  function reqTableDataFunc(params: any) { // 请求table接口数据
    return req.list(API_URL_STORE_DEVICE, Object.assign({ deviceType: deviceType }, params))
  }
  function searchFunc () { // 点击【查询】按钮点击事件
    btnLoading.value = true
    infoTable.value.refTable(true)
  }
  function addFunc () { // 业务通用【新增】 函数
    infoAddOrEdit.value.show({ deviceType: deviceType })
  }
  function editFunc (record: any) { // 业务通用【修改】 函数
    infoAddOrEdit.value.show(record)
  }
  function bindFunc (record: any) { // 绑定设备函数
    bind.value.show(record)
  }
  function deleteBatchFunc() {  // 批量删除
    if (vdata.allotDeviceIdList.length < 1) {
      $infoBox.message.error('请选择设备')
    } else {
      $infoBox.confirmDanger('确认删除？', '', () => {
        $batchDelDevice(vdata.allotDeviceIdList.join(',')).then((res: any) => {
          infoTable.value.refTable(true)
          $infoBox.message.success('删除成功')
        })
      })
    }
  }
  function delFunc (recordId: any) { // 业务通用【删除】 函数
    $infoBox.confirmDanger('确认删除？', '', () => {
        $batchDelDevice(recordId).then((res: any) => {
            infoTable.value.refTable(true)
            $infoBox.message.success('删除成功')
          })
    })
  }
  function onReset(){ //重置搜索内容
    vdata.searchData = {}
  }
  function updateState (recordId, state) { // 【更新状态】
      const title = state ? '确认启用？' : '确认禁用？'
      const content = state ? '' : '禁用后该设备将无法使用！'
      return new Promise<void>((resolve, reject) => {
        $infoBox.confirmDanger(title, content, () => {
          return reqLoad.updateById(API_URL_STORE_DEVICE, recordId, { state: state }).then(res => {
            searchFunc()
            resolve()
          }).catch(err => reject(err))
        },
          () => {
          reject(new Error())
        })
      })
    }

    // 按批次号划拨
  function allotByBatchIdFunc() {
    vdata.allotObject.allotType = 'batch'
    vdata.allotObject.batchId = ''
    vdata.allotByBatchIdVisible = true
  }
  
  // 按批次号划拨，批次号输入完成
  function allotOk() {
    allotFormModel.value.validate().then((valid: any) =>{
      vdata.allotByBatchIdVisible = false
      jeepayModelAgentList.value.show()
    })
  }

    // 表格多选
  function infoTableSelectChangeFunc(selectedRowKeys, selectedRows) {
    vdata.allotDeviceIdList = selectedRowKeys
  }

  // 勾选划拨设备
  function allotBatchFunc() {
    if (vdata.allotDeviceIdList.length < 1) {
      $infoBox.message.error('请选择设备')
    } else {
      vdata.allotObject.allotType = 'select'
      jeepayModelAgentList.value.show()
    }
  }

  // 划拨单个设备
  function allotFunc(record) {
    vdata.allotObject.allotType = 'select'
    vdata.allotDeviceIdList = []
    vdata.allotDeviceIdList.push(record.deviceId)

    jeepayModelAgentList.value.show()
  }

  // 解绑设备
  function deBindFunc(recordId) {
    const title = '确认解绑？'
    const content = '解绑后商户将无法使用该设备！'
    $infoBox.confirmDanger(title, content, () => {
      return $unbindDevice(recordId).then(res => {
        infoTable.value.refTable(true)
        $infoBox.message.success('解绑成功')
      })
    })
  }

  // 代理商选择完成
  function searchAgentFinishFunc(selectObject) {

    if (vdata.allotDeviceIdList.length > 0) {
      vdata.allotObject.allotDeviceIds = vdata.allotDeviceIdList.join(',')
    }
    vdata.allotObject.agentNo = selectObject[0]
       vdata.allotObject.allotOrRecover = selectObject[1]

    $allotDevice(vdata.allotObject).then(res => {
      vdata.allotDeviceIdList = [] // 清空多选
      $infoBox.message.success('保存成功')
      jeepayModelAgentList.value.close()
      searchFunc()
    })
  }

  function alipayIotBindShowFunc (record: any) { // 蚂蚁店铺绑定管理
    req.list(API_URL_MCH_STORE_LIST, { 'pageSize': -1, 'alipayShopStatus': '99', 'mchNo': record.mchNo }).then(res => { // 门店下拉选择列表
      vdata.storeList =  res.records || []
      if (vdata.storeList.length > 0 && vdata.storeList.some(i => i.storeId == record.storeId)) {
        vdata.alipayIotBindObject.storeId = record.storeId
      }
    })
    vdata.alipayIotBindObject.deviceId = record.deviceId
    vdata.alipayIotBindObject.alipayBindState = record.alipayBindState

    vdata.alipayIotBindShow = true
  }
  function alipayIotBindFunc(recordId, alipayBindState) { // 绑定蚂蚁店铺设备
    vdata.alipayIotBindObject.alipayBindState = alipayBindState
    reqLoad.add(API_ALIPAY_IOT + '/bind/' + recordId, vdata.alipayIotBindObject).then(res => {
      infoTable.value.refTable(true)
      $infoBox.message.success('操作成功')
      vdata.alipayIotBindShow = false
    }).catch(err =>console.log(err))
  }
  function alipayIotUnBindFunc(recordId) { // 解绑蚂蚁店铺设备
    $infoBox.confirmDanger('解绑蚂蚁店铺', '确定解绑蚂蚁店铺吗？', () => {
      return alipayIotBindFunc(recordId, 0)
    })
  }
</script>
